summaryrefslogtreecommitdiffstats
path: root/target/linux/brcm63xx/base-files
diff options
context:
space:
mode:
authorJonas Gorski <jogo@openwrt.org>2012-11-24 14:19:22 +0000
committerJonas Gorski <jogo@openwrt.org>2012-11-24 14:19:22 +0000
commit60e0e0d6e64604de77dd6a5daf641b80408c1701 (patch)
treec7b5c4830a44557dcd46979c3246c80d56120a9a /target/linux/brcm63xx/base-files
parent746b4cec068c04fe469f408784b6eced42a05791 (diff)
downloadmaster-31e0f0ae-60e0e0d6e64604de77dd6a5daf641b80408c1701.tar.gz
master-31e0f0ae-60e0e0d6e64604de77dd6a5daf641b80408c1701.tar.bz2
master-31e0f0ae-60e0e0d6e64604de77dd6a5daf641b80408c1701.zip
bcm63xx: Add a fixup for rt2x00 devices.
This patch adds support for defining rt2x00 eeprom data. This eeprom data can be extracted from flash or loaded directly from a firmware file. Signed-off-by: Álvaro Fernández Rojas <noltari@gmail.com> SVN-Revision: 34322
Diffstat (limited to 'target/linux/brcm63xx/base-files')
-rw-r--r--target/linux/brcm63xx/base-files/etc/hotplug.d/firmware/10-rt2x00-eeprom39
1 files changed, 39 insertions, 0 deletions
diff --git a/target/linux/brcm63xx/base-files/etc/hotplug.d/firmware/10-rt2x00-eeprom b/target/linux/brcm63xx/base-files/etc/hotplug.d/firmware/10-rt2x00-eeprom
new file mode 100644
index 0000000000..46be9d3f99
--- /dev/null
+++ b/target/linux/brcm63xx/base-files/etc/hotplug.d/firmware/10-rt2x00-eeprom
@@ -0,0 +1,39 @@
+#!/bin/sh
+# Based on gabors ralink wisoc implementation.
+
+rt2x00_eeprom_die() {
+ echo "rt2x00 eeprom: " "$*"
+ exit 1
+}
+
+rt2x00_eeprom_extract() {
+ local part=$1
+ local offset=$2
+ local count=$3
+ local mtd
+
+ . /etc/functions.sh
+
+ mtd=$(find_mtd_part $part)
+ [ -n "$mtd" ] || \
+ rt2x00_eeprom_die "no mtd device found for partition $part"
+
+ dd if=$mtd of=/lib/firmware/$FIRMWARE bs=1 skip=$offset count=$count || \
+ rt2x00_eeprom_die "failed to extract from $mtd"
+}
+
+[ -e /lib/firmware/$FIRMWARE ] && exit 0
+
+. /lib/brcm63xx.sh
+
+board=$board_name
+
+case "$FIRMWARE" in
+"RT3062.eeprom" )
+ case $board in
+ *)
+ rt2x00_eeprom_die "board $board is not supported yet"
+ ;;
+ esac
+ ;;
+esac